%global eclipse_base            %{_datadir}/eclipse
%global cdtreq                  1:8.1.0
%global photran_build_id        201305101559
#global photran_git_tag         PTP_6_0_2
%global photran_git_tag         638a2ad75f754b63199724669aca8cab69d0b302

Summary:        Fortran Development Tools (Photran) for Eclipse
Name:           eclipse-photran
Version:        8.1.0
Release:        0.3.20130510git71fea65%{?dist}
License:        EPL
Group:          Development/Tools
URL:            http://www.eclipse.org/ptp

# The following tarballs were downloaded from the git repositories
Source0:        http://git.eclipse.org/c/ptp/org.eclipse.photran.git/snapshot/org.eclipse.photran-%{photran_git_tag}.tar.gz
# These are made with makesource.sh
#Source0:        org.eclipse.photran-%{photran_git_tag}.tar.xz
Source1:        makesource.sh

BuildRequires:  maven-local
BuildRequires:  tycho
BuildRequires:  eclipse-cdt >= %{cdtreq}
BuildArch:      noarch
Requires:       eclipse-cdt >= %{cdtreq}

%description
An Eclipse-based Integrated Development Environment for Fortran.


%package intel
Summary:        Intel Fortran compiler support for Photran
Group:          Development/Libraries
Requires:       eclipse-photran = %{version}-%{release}

%description intel
This feature packages the plugins required to support
the Intel Fortran compiler in Photran/FDT.


%package xlf
Summary:        IBM XLF Compiler Support
Group:          Development/Libraries
Requires:       eclipse-photran = %{version}-%{release}

%description xlf
Error parser and managed build tool chain for the IBM XLF compiler.


%prep
%setup -q -n org.eclipse.photran-%{photran_git_tag}
# Fix tycho version
tychover=$(sed -ne '/<version>/{s/.*>\(.*\)<.*/\1/;p;q}' < /usr/share/maven-fragments/tycho)
sed -i -e "/tycho-version/s/>.*</>${tychover}</" pom.xml

# We need to rebuild this jar from the sources within it
pwd
mkdir cdtdb-4.0.3-eclipse
pushd cdtdb-4.0.3-eclipse
unzip -q ../org.eclipse.rephraserengine.core/cdtdb-4.0.3-eclipse.jar
find -name \*.class -exec rm {} +
popd
# Delete any other jars in the project
find -name \*.jar -exec rm {} +
# This prevents the Photran Intel feature from building
sed -i -e 's/os="linux"//' org.eclipse.photran.intel-feature/feature.xml
#Fix line endings, causes problems with pdebuild link names
#find -name MANIFEST.MF -exec sed -i -e 's|\r||' {} +


%build
export JAVA_HOME=%{java_home}
export PATH=/usr/bin:$PATH
# Build the helper jar first
pushd cdtdb-4.0.3-eclipse
classpath=$(echo /usr/lib*/eclipse/plugins/org.eclipse.equinox.common_*.jar | sed -e 's/ /:/g')
find -name \*java -exec javac -classpath $classpath '{}' +
jar cf ../org.eclipse.rephraserengine.core/cdtdb-4.0.3-eclipse.jar *
popd
#Interferes with feature build
rm -rf cdtdb-4.0.3-eclipse
# Build the projects
mvn-rpmbuild -DforceContextQualifier=%{photran_build_id} install


%install
mkdir -p %{buildroot}%{eclipse_base}/dropins/photran/eclipse/{features,plugins}

# Features
for jar in org.eclipse.photran.repo/target/repository/features/*.jar
do
  name=$(basename $jar .jar)
  unzip -u -d %{buildroot}%{eclipse_base}/dropins/photran/eclipse/features/$name $jar
  sed -ne '/id=/s#.*"\(.*\)"#%{eclipse_base}/dropins/photran/eclipse/plugins/\1_*.jar#gp' %{buildroot}%{eclipse_base}/dropins/photran/eclipse/features/$name/feature.xml | tail -n +2 > files.$name
done
# Plugins
cp -u org.eclipse.photran.repo/target/repository/plugins/*.jar \
   %{buildroot}%{eclipse_base}/dropins/photran/eclipse/plugins/

# special case for rephraserengine feature
sed -i -e '/org.eclipse.rephraserengine_/d' files.org.eclipse.photran_%{version}.%{photran_build_id}


%files -f files.org.eclipse.photran_%{version}.%{photran_build_id} -f files.org.eclipse.rephraserengine_%{version}.%{photran_build_id}
%doc org.eclipse.photran-feature/epl-v10.html
%dir %{eclipse_base}/dropins/photran
%dir %{eclipse_base}/dropins/photran/eclipse
%dir %{eclipse_base}/dropins/photran/eclipse/features
%dir %{eclipse_base}/dropins/photran/eclipse/plugins
%{eclipse_base}/dropins/photran/eclipse/features/org.eclipse.photran_*
%{eclipse_base}/dropins/photran/eclipse/features/org.eclipse.rephraserengine_*

%files intel -f files.org.eclipse.photran.intel_%{version}.%{photran_build_id}
%doc org.eclipse.photran-feature/epl-v10.html
%{eclipse_base}/dropins/photran/eclipse/features/org.eclipse.photran.intel_*

%files xlf -f files.org.eclipse.photran.xlf_%{version}.%{photran_build_id}
%doc org.eclipse.photran-feature/epl-v10.html
%{eclipse_base}/dropins/photran/eclipse/features/org.eclipse.photran.xlf_*


%changelog
* Fri May 10 2013 Orion Poplawski <orion@cora.nwra.com> - 8.1.0-0.3.20130510git71fea65
- Update to current git

* Wed May 1 2013 Orion Poplawski <orion@cora.nwra.com> - 8.1.0-0.2.20130501git71fea65
- Update to current git

* Wed Apr 10 2013 Orion Poplawski <orion@cora.nwra.com> - 8.1.0-0.1.20130409git
- Split photran out of eclipse-ptp package
